VERSION 5.00
Begin VB.Form frmaNuMetDemo 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "aNuMet_Demo"
   ClientHeight    =   6075
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   12825
   Icon            =   "aNuMet_Demo.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   6075
   ScaleWidth      =   12825
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "Test Matrix Parser"
      Default         =   -1  'True
      Height          =   375
      Left            =   7920
      TabIndex        =   14
      Top             =   5520
      Width           =   1515
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Test EqParser"
      Height          =   375
      Left            =   6240
      TabIndex        =   13
      Top             =   5520
      Width           =   1515
   End
   Begin VB.CommandButton btnSist 
      Caption         =   "Solve Sys&tem"
      Height          =   375
      Left            =   4560
      TabIndex        =   11
      Top             =   5520
      Width           =   1515
   End
   Begin VB.TextBox Text1 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4575
      Left            =   5760
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   8
      Top             =   660
      Width           =   6855
   End
   Begin VB.CommandButton btnAbout 
      Caption         =   "&About"
      Height          =   375
      Left            =   10920
      TabIndex        =   7
      Top             =   5520
      Width           =   795
   End
   Begin VB.CommandButton btnEnd 
      Cancel          =   -1  'True
      Caption         =   "&End"
      Height          =   375
      Left            =   11880
      TabIndex        =   5
      Top             =   5520
      Width           =   795
   End
   Begin VB.CommandButton btnGO 
      Caption         =   "&Show Curve"
      Height          =   375
      Left            =   3000
      TabIndex        =   3
      Top             =   5520
      Width           =   1395
   End
   Begin VB.HScrollBar HScroll1 
      Height          =   315
      Left            =   2220
      TabIndex        =   2
      Top             =   5520
      Width           =   675
   End
   Begin VB.TextBox txtK 
      Alignment       =   2  'Center
      Height          =   315
      Left            =   1560
      TabIndex        =   1
      Text            =   "3"
      Top             =   5520
      Width           =   555
   End
   Begin VB.PictureBox pic1 
      AutoRedraw      =   -1  'True
      Height          =   4155
      Left            =   300
      ScaleHeight     =   4095
      ScaleWidth      =   5175
      TabIndex        =   0
      Top             =   660
      Width           =   5235
   End
   Begin VB.Label Label5 
      BackColor       =   &H0000FFFF&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H000000FF&
      Height          =   315
      Left            =   360
      TabIndex        =   12
      Top             =   0
      Width           =   12195
   End
   Begin VB.Label Label4 
      Caption         =   "TextBox"
      Height          =   195
      Left            =   5820
      TabIndex        =   10
      Top             =   420
      Width           =   2355
   End
   Begin VB.Label Label3 
      Caption         =   "PictureBox"
      Height          =   195
      Left            =   360
      TabIndex        =   9
      Top             =   420
      Width           =   2355
   End
   Begin VB.Label Label2 
      Caption         =   "Polinomial Rank"
      Height          =   255
      Left            =   360
      TabIndex        =   6
      Top             =   5580
      Width           =   1155
   End
   Begin VB.Label Label1 
      Caption         =   "text"
      Height          =   495
      Left            =   360
      TabIndex        =   4
      Top             =   4980
      Width           =   5115
   End
End
Attribute VB_Name = "frmaNuMetDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
'Visual Basic 6.0 Demo program for aNuMet.dll (DLL For Numerical calculations (methods)
'
';by Carlo Somigliana (somic@libero.it)
';
';**********************************************************
';Pls report any bug and/or comment to me, Carlo Somigliana,
';at this e-mail address: somic@libero.it
';Bug fix will be e-mailed free of charge.
';**********************************************************

'GENERAL notes:
'------------------------
';The DLL uses standard Windows API calling convention
';All calls to be declared as Functions, returning an ExitCode (Long or .l), expecially in PB, to avoid Debug problems
';Matrices must be passed with a pointer (PB i.e @a()) or first element (VB i.e. a(1,1)) (see examples)
';Matrices' elements are all Double (.d = 8 bytes)
';Procedures "aElemOrder" or "aElemOrderSet" must be always called before any other call to set aElemOrder value inside DLL
';This DLL has no run-time error handling
';Simbol * means a pointer to a variable (Matrix, Long, Double,...)
';Simbol @ means memory address of variable/array/etc
';Parameter rc.l always means Squared Matrix (Rows = Col)

'Important VB notes:
'-------------------
';Matrices must be already dimensioned (preferably Option Base 1 - from 1 To n)
';Matrices must be passed with first element (see examples)
';Arrays (Matrices) must be declared 'As Any' (see samples) in "Declare Function" instructions
';Long values (.l in PureBasic) must be declared 'ByRef'
';All calls to be declared as Functions, returning an ExitCode (Long)
';Returned values when Double must be declared 'ByRef' and are always the last parameter

'In this examples, the VB function declaration follows the PureBasic ProcedureDLL declaration

Option Explicit
Option Base 1

Dim w As String * 1000 'returned string
Dim ret& 'returned value

'This Array can be dinamically redimensioned, Preserving the values
Dim p#(1 To 2, 1 To 5) '5 is the number of Observed Points, 1 is X Coordinate, 2 is Y Coordinate

Private Sub btnSist_Click()
    Dim vetX#(1 To 3), mtrA#(1 To 3, 1 To 3), vetB#(1 To 3)
    Dim ret&, DetA#, rc&
    
    w = Space$(1000) 'create string buffer
    'w = String$(1000, Chr$(0)) 'create string buffer
    
    Text1 = "Solve the System {vX(3)} = [A(3,3)]*{vB(3)}; result in *{vX(0)}" + vbCrLf + vbCrLf
    
    'fill matrix
    mtrA#(1, 1) = 0: mtrA#(1, 2) = 1: mtrA#(1, 3) = 4.1
    mtrA#(2, 1) = 78.36: mtrA#(2, 2) = 90: mtrA#(2, 3) = 72.2747
    mtrA#(3, 1) = 7.0024: mtrA#(3, 2) = 9.0031: mtrA#(3, 3) = 62.6245
    
    'get and show matrix elements
    ret = aPrintEx(mtrA(1, 1), 3, 3, "MsgBox", "", "mtrA()=", "", w)
    Text1 = Text1 + Left$(w, ret) + vbCrLf + vbCrLf
    
    'get and show vector elements
    vetB(1) = 4: vetB(2) = 3: vetB(3) = 7
    ret = aPrintEx(vetB(1), 3, 1, "String", "0.000", "vetB()=", "", w)
    Text1 = Text1 + Left$(w, ret) + vbCrLf + vbCrLf
        
    'resolve system
    ret = aSist(mtrA(1, 1), 3, vetB(1), vetX(1))
        
    'get and show vector elements
    ret = aPrintEx(vetX(1), 3, 1, "", "", "vetX()=", "", w)
    Text1 = Text1 + Left$(w, ret) + vbCrLf + vbCrLf
    'ret = aShow(vetX(1), 3, 1) 'uses DLL internal procedure to Show result
    Text1.SelLength = Len(Text1.text) 'scroll down text
    
End Sub

'show (plot) Polinomial curve
Sub Show_PolinCurve(p#(), Coeff#())
Dim i&, x#, y#, MaxY#, clr&, y1#
Dim res&

    'setup chart picture
    pic1.ScaleWidth = 10: pic1.ScaleHeight = 100
    MaxY = pic1.ScaleHeight 'To invert Scale
    pic1.FillStyle = 0
    pic1.Cls
    
    'plot Observation Points
    If UBound(p, 2) = 2 Then
        For i = 1 To 5
            clr = RGB(Rnd * 255, Rnd * 255, Rnd * 255) 'Just a little fantasy
            pic1.FillColor = clr
            pic1.Circle (p(i, 1), (MaxY - p(i, 2))), 0.1
        Next i
    ElseIf UBound(p, 1) = 2 Then
        For i = 1 To 5
            clr = RGB(Rnd * 255, Rnd * 255, Rnd * 255) 'Just a little fantasy
            pic1.FillColor = clr
            pic1.Circle (p(1, i), (MaxY - p(2, i))), 0.1
        Next i
    End If
    
    i = UBound(Coeff())
    
    'plot polinomial curve
    For x = 0 To 10 Step 0.1
    
        'Polinomial is y=Coeff(0) + Coeff(1) * x + Coeff(2) * x^2 + ... + Coeff(k) * x^(k-1)
        res = aGetYPolin(x, Coeff(1), i, y)
        
        pic1.PSet (x, MaxY - y)
    
    Next x

End Sub

Private Sub Command1_Click()
    Test_EqParser
End Sub

Private Sub Command2_Click()
Dim st$, txt2$, mMemID&, r1&, c1&, dRet#, strAddr&

ret = ReSetEqParser()       'reset dll
Call ShowMsgs(0)            'no debug messages

'first we create and store some matrices into the DLL

'string matrix, separator is the 'pipe' simbol '|'
'this format supports expressions' matrix elements are parsed (spaces are trimmed) by SetStrMatrix function
'    name |rows|cols|mA(0,0)|mA(0,1)|...
st = "[mB]|   3|   3|      0|      1| 2| 1.2| 2.2| 3.2| 1| 2| 16.6866371434679*sin(0.5)" '
ret = SetStrMatrix(st, 1, 1)                'store matrix in DLL
st = "[vB]|   3|   0|     1|      2| 4" '
ret = SetStrMatrix(st, 1, 0)                'store vector in DLL, it will be stored as a matrix mB2(2, 0)

'std matrix
Dim mC#(0 To 2, 0 To 2)
mC(0, 0) = 1: mC(0, 1) = 1: mC(0, 2) = 4
mC(1, 0) = 0: mC(1, 1) = 3: mC(1, 2) = 1
mC(2, 0) = 4: mC(2, 1) = 3: mC(2, 2) = 5
ret = SetMatrix("[mC]", mC(0, 0), 3, 3, 1)
GoTo lastSample

'1. simple calculation
'---------------------
txt2 = "det([mB] + [mC])"
ret = e_eval(txt2, dRet, 0)
' we know result is a number
Debug.Print "Result of: " + txt2 + " is " + Str(dRet)


'2. sample calculation
'----------------------
txt2 = "([mB]*[mB] + 2*[mC]*[mB] - [mC]^2)"
ret = e_eval(txt2, dRet, 0)
' if we don't know if result is a number or a matrix
If GetResultType() = nnIsMatrix Then                                        'also if ret = #nnIsNumber
    mMemID = FindMatrix(Str(dRet), (SrcMatrPtr + RetMatrPtr), r1, c1)       'get result matrix stored in DLL
    ReDim mResult#(0 To r1 - 1, 0 To c1 - 1)                                'dimension proper matrix
    ret = GetMatrixByLong(mMemID, mResult(0, 0), r1, c1)                    'store result in Matrix mResult()
    ret = aPrint(mResult(0, 0), r1, c1, "MsgBox", "", "[mResult] = ", "")   'show mResult

Else
    Debug.Print "Result: " + Str(dRet)
End If

'3. sample calculation
'---------------------
txt2 = "([mB] + [mC])^2"
ret = e_eval(txt2, dRet, 0)
'if we don't need the matrix content and we know the dimensions, we can show the results only
ret = aShowByLong(CLng(dRet), 3, 3)                                         'show Result

'4. sample calculation
'---------------------
txt2 = "([mB] * [mB]I)"
ret = e_eval(txt2, dRet, 0)
'if we don't need the matrix content and we know the dimensions, we can show the results only
ret = aShowByLong(CLng(dRet), 3, 3)                                         'show Result
st = PeekS(ret)
Text1 = "Result of " + txt2 + " is " + vbCrLf + st + vbCrLf + vbCrLf

'5. sample calculation
'---------------------
txt2 = "(2*[mB]I)"
ret = e_eval(txt2, dRet, 0)
'if we don't need the matrix content and we know the dimensions, we can only show the results
If GetResultType() = nnIsMatrix Then                                        'also if ret = #nnIsNumber
    mMemID = FindMatrix(Str(dRet), (SrcMatrPtr + RetMatrPtr), r1, c1)       'get result matrix stored in DLL
    ReDim mResult#(0 To r1 - 1, 0 To c1 - 1)                                'dimension proper matrix
    ret = GetMatrixByLong(mMemID, mResult(0, 0), r1, c1)                    'store result in Matrix mResult
    
    strAddr = aPrint(mResult(0, 0), r1, c1, "String", "", "", "")           'get mResult
    st = PeekS(strAddr)                                                     'get text of returned string
    Text1 = Text1 + "Result of " + txt2 + " is " + vbCrLf + st              'show result in the textbox
    
Else
    Debug.Print "Result of : "; txt2 + " is " + Str(dRet)

End If

lastSample:
'6. sample calculation
'---------------------
txt2 = "syst((2*[mC]);([vB]+[vB])) + [vB]"
ret = e_eval(txt2, dRet, 0)
ret = aShowByLong(CLng(dRet), 3, 1)                                         'show Result
st = PeekS(ret)
Text1 = Text1 + "Result of " + txt2 + " is " + vbCrLf + st + vbCrLf + vbCrLf

'7. sample calculation
'---------------------
txt2 = "vcoeff((2*[mC]); ([vB]+[vB]); (3-1))"
ret = e_eval(txt2, dRet, 1)
ret = aShowByLong(CLng(dRet), 3, 1)                                         'show Result
st = PeekS(ret)
Text1 = Text1 + "Result of " + txt2 + " is " + vbCrLf + st + vbCrLf + vbCrLf

'7. sample error (vB is not squared, determinant is not existing)
'----------------------------------------------------------------
txt2 = "det([vB])"
ret = e_eval(txt2, dRet, 1)
If GetE_Error() = aMatrOK Then                                              'test error
    Debug.Print txt2 + " = " + Str(dRet)
Else
    Debug.Print "Error n. = " + Str(GetE_Error())
End If

End Sub

'This Array can NOT be dinamically redimensioned, without resetting the values
'Dim P#(5, 2) '5 is the number of Observed Points, 1 is X Coordinate, 2 is Y Coordinate
Private Sub Form_Load()
Dim MaxI&, st$, i&, k&, ret&, ln&
Dim s1$, s2$, s$, l&

    Label5.Caption = "This VB program is a Demo of the use of the aNuMet.dll. Important notes are reported at the begin of the form and in the Readme.txt file."
          
    MaxI = IIf(UBound(p, 1) > UBound(p, 2), UBound(p, 1), UBound(p, 2))
    HScroll1.Max = MaxI - 1 'Max Rank of the Polinomial Curve
    HScroll1.Min = 1                'Min Rank = Line
    HScroll1.Value = 3
    Label1 = "Change Rank Value and press [&Show] to see Polinomial Curve" + vbCr
    Label1 = Label1 + "(Rank to go from 1 to 4 because of 5 Observation Points)"
    
    Dim a(1 To 2, 1 To 2) As Double
    a(1, 2) = 2
    a(2, 1) = 1 '(<>2
    
    'initialize DLL, setting aElemOrder
    'Parameters: Tp values: 0=Detect, 1=DetectStr, 2=Set, 3=Get
    ret = aElemOrderEx(a(1, 1), 0)

End Sub

Sub Test_EqParser()
    'show Equation Parser functionalities
    Dim txt1$, dRet As Double, ret&, sList1 As String * 100, sList2 As String * 100, z1#
    
    Dim dbl As Double
    dbl = fact(5)
    Text1 = Text1 + "Factorial sample: 5! = " & dbl & vbCrLf & vbCrLf
    
    'define variables
    ret = SetVarFunct("xx", "12", 0)
    ret = SetVarFunct("yy", "2", 0)
    
    'define functions (1=verify functions' name ambiguity)
    ret = SetVarFunct("func1", "xx+yy", 1)
    ret = SetVarFunct("func2", "xx-yy", 1)
    
    'define equation
    txt1 = "xx+ func1 + func2 + sin(yy*to_rad) - Log(10)/(1+yy^2)"
    
    'show equation
    Text1 = Text1 + "Expression: " + vbCrLf + "(" + txt1 + "):"
    
    'get and show variables and functions
    ret = GetVarFuncList(sList1, 100, "vars") 'get variables' list
    ret = GetVarFuncList(sList2, 100, "func") 'get functions' list
    Text1 = Text1 + vbCrLf + "with Variables: " + sList1
    Text1 = Text1 + vbCrLf + "and Functions: " + sList2
    
    ' evaluate equation
    ret = e_eval(txt1, dRet, 1)
    
    'show result
    Text1 = Text1 + vbCrLf & "Result is: " & dRet & vbCrLf & vbCrLf
    
    ' set single variable 'x' equation
    txt1 = "1 + 12*x - Log(x) + 2*x^2"
    Text1 = Text1 + "Integration (trapezoidal method) between 1 to 1000 with 500 steps: " + vbCrLf
    Text1 = Text1 + "Equation y=(" + txt1 + "):"
    ' integrate equation between 1 to 1000 with 500 steps
    ret = Integrate(txt1, 1, 1000, 500, i_trapezoidal, "x", dRet)
    'show result
    Text1 = Text1 + vbCrLf & "Result is: " & dRet & vbCrLf
    
    Dim xx&
    'test loop
    txt1 = "z1^2"
    Text1 = Text1 + vbCrLf + "Equation: " & txt1
    For z1 = 1 To 10
    
        ret = SetVarFunct("z1", Str(z1), 0)
        ret = e_eval(txt1, dRet, 1)
        
        Text1 = Text1 + vbCrLf + "  variable z1=" & z1 & ", result =" & Str(dRet)
        
    Next z1
End Sub
Private Sub btnAbout_Click()
    Dim i&, st
    st = aAbout(i)
End Sub

Private Sub btnEnd_Click()
    End
End Sub

Private Sub btnGO_Click()

    'Show Polinomial Curve
    Show_mPolin
    
    'show some matrix operations
    TestRandomMatrix

End Sub

Sub Show_mPolin()
Dim k&, Coeff#()
Dim res&, retStr As String * 1000, strAddr&

    'set Observed Points Coordinates
    p#(1, 1) = 0:
    p#(1, 2) = 1:
    p#(1, 3) = 4.1
    p#(1, 4) = 7.0024:
    p#(1, 5) = 9.0031
    
    p#(2, 1) = 78.36:
    p#(2, 2) = 90:
    p#(2, 3) = 72.2747
    p#(2, 4) = 62.6245:
    p#(2, 5) = 52.934
    
    k = txtK + 1 'k rank of the Matrix => Polinomial Rank = k-1 <= n-2
    ReDim Coeff#(1 To k)
    
    
    res = aCalcCoeffPolin(p#(1, 1), 5, k, Coeff(1))
        
    'show Coeffiecients in the debug window
    res = aPrintEx(Coeff(1), k, 1, "", "", "aPrintEx: vectCoeff()=", "", retStr)
    If res <> 0 Then Debug.Print Left$(retStr, res) + vbCrLf
    
    'alternative way
    strAddr = aPrint(Coeff(1), k, 1, "String", "", "aPrint: vectCoeff()=", "")
    Debug.Print PeekS(strAddr) + vbCrLf
    
    'show Polinomial Curve in the picturebox
    Show_PolinCurve p#(), Coeff#()
  
    Text1.SelLength = Len(Text1.text) 'scroll down text
  
End Sub

Private Sub HScroll1_Change()
    txtK = HScroll1.Value
End Sub

Sub TestRandomMatrix()
Dim ret, r&, c&, n&, a#(), AI#(), AT#(), DetA#, DetAI#, DetAT#
  
    w = Space$(1000) 'create string buffer
    
    ret = InputBox("Input order of the sample Random Matrix: ", "VBMatr", 4)
    If IsNumeric(ret) Then n = ret Else n = 4
    
    Text1 = "Test Random Matrix" + vbCrLf + vbCrLf
        
    'set random matrix 3x3
    ReDim a#(n, n)
    For r = 1 To n
        For c = 1 To n
            a(r, c) = 10 * Rnd() - 5
        Next c
    Next r
    
    ReDim AT#(n, n)
    ReDim AI#(n, n)
    
    'duplicate [A] in [A]I and [A]T
    ret = aDupl(a(1, 1), n, n, AI(1, 1))
    ret = aDupl(a(1, 1), n, n, AT(1, 1))
    
    'print
    ret = aPrintEx(a(1, 1), n, n, "", "", "Matrix [A] is:", "", w)
    Text1 = Text1 + Left$(w, ret) + vbCrLf + vbCrLf
    
    ret = aDet(a(1, 1), n, DetA) 'calculate determinant
    Text1 = Text1 + "Determinant of [A] is " & DetA & vbCrLf & vbCrLf
    
    'create [A]T = Trasposed matrix of [A]
    ret = aTrasp(AT(1, 1), n, n)
    'print
    w = ""
    ret = aPrintEx(AT(1, 1), n, n, "MsgBox", "0.000", "Matrix [A]T is", "", w)
    Text1 = Text1 + Left$(w, ret) + vbCrLf + vbCrLf
    
    ret = aDet(AT(1, 1), n, DetAT)
    Text1 = Text1 + "Determinant of [A]T is " & DetAT & vbCrLf & vbCrLf
    
    'invert AI# (mDet[A]I = 1/mDet[A])
    ret = aInv(AI#(1, 1), n)
    'print
    ret = aPrintEx(AI(1, 1), n, n, "String", "", "Matrix [A]I is:", "", w)
    Text1 = Text1 + Left$(w, ret) + vbCrLf + vbCrLf
    
    ret = aDet(AI(1, 1), n, DetAI)
    Text1 = Text1 + "Determinant of [A]I is " & DetAI & vbCrLf & vbCrLf
  
    Text1.SelLength = Len(Text1.text) 'scroll down text
  
End Sub

